%if 0%{?fedora} || 0%{?rhel} == 6
%global with_devel 1
%global with_bundled 0
%global with_debug 0
# it takes too much time
%global with_check 0
%global with_unit_test 1
%else
%global with_devel 0
%global with_bundled 0
%global with_debug 0
%global with_check 0
%global with_unit_test 0
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%global provided_packages    aws internal/apierr internal/endpoints internal/protocol internal/signer service

%global provider        github
%global provider_tld    com
%global project         aws
%global repo            aws-sdk-go
# https://github.com/aws/aws-sdk-go
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          f096b7d61df3d7d6d97f0e701f92616d1ea5420d
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           golang-%{provider}-%{project}-%{repo}
Version:        0.9.5
Release:        1%{?dist}
Summary:        AWS SDK for the Go programming language
License:        ASL 2.0
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%description
%{summary}

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check}
BuildRequires: golang(github.com/lsegal/gucumber)
BuildRequires: golang(github.com/stretchr/testify/assert)
BuildRequires: golang(github.com/vaughan0/go-ini)
%endif

Requires:      golang(github.com/lsegal/gucumber)
Requires:      golang(github.com/stretchr/testify/assert)
Requires:      golang(github.com/vaughan0/go-ini)

Provides:      golang(%{import_path}) = %{version}-%{release}
Provides:      golang(%{import_path}/aws) = %{version}-%{release}
Provides:      golang(%{import_path}/aws/awserr) = %{version}-%{release}
Provides:      golang(%{import_path}/aws/awsutil) = %{version}-%{release}
Provides:      golang(%{import_path}/aws/corehandlers) = %{version}-%{release}
Provides:      golang(%{import_path}/aws/credentials) = %{version}-%{release}
Provides:      golang(%{import_path}/aws/defaults) = %{version}-%{release}
Provides:      golang(%{import_path}/aws/ec2metadata) = %{version}-%{release}
Provides:      golang(%{import_path}/aws/request) = %{version}-%{release}
Provides:      golang(%{import_path}/aws/service) = %{version}-%{release}
Provides:      golang(%{import_path}/service) = %{version}-%{release}
Provides:      golang(%{import_path}/service/autoscaling) = %{version}-%{release}
Provides:      golang(%{import_path}/service/autoscaling/autoscalingiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudformation) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudformation/cloudformationiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudfront) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudfront/cloudfrontiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudhsm) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudhsm/cloudhsmiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudsearch) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudsearch/cloudsearchiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudsearchdomain) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudsearchdomain/cloudsearchdomainiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudtrail) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudtrail/cloudtrailiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudwatch) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudwatch/cloudwatchiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudwatchlogs) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cloudwatchlogs/cloudwatchlogsiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/codedeploy) = %{version}-%{release}
Provides:      golang(%{import_path}/service/codedeploy/codedeployiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cognitoidentity) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cognitoidentity/cognitoidentityiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cognitosync) = %{version}-%{release}
Provides:      golang(%{import_path}/service/cognitosync/cognitosynciface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/configservice) = %{version}-%{release}
Provides:      golang(%{import_path}/service/configservice/configserviceiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/datapipeline) = %{version}-%{release}
Provides:      golang(%{import_path}/service/datapipeline/datapipelineiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/directconnect) = %{version}-%{release}
Provides:      golang(%{import_path}/service/directconnect/directconnectiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/directoryservice) = %{version}-%{release}
Provides:      golang(%{import_path}/service/directoryservice/directoryserviceiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/dynamodb) = %{version}-%{release}
Provides:      golang(%{import_path}/service/dynamodb/dynamodbiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/ec2) = %{version}-%{release}
Provides:      golang(%{import_path}/service/ec2/ec2iface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/ecs) = %{version}-%{release}
Provides:      golang(%{import_path}/service/ecs/ecsiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/efs) = %{version}-%{release}
Provides:      golang(%{import_path}/service/efs/efsiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/elasticache) = %{version}-%{release}
Provides:      golang(%{import_path}/service/elasticache/elasticacheiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/elasticbeanstalk) = %{version}-%{release}
Provides:      golang(%{import_path}/service/elasticbeanstalk/elasticbeanstalkiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/elastictranscoder) = %{version}-%{release}
Provides:      golang(%{import_path}/service/elastictranscoder/elastictranscoderiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/elb) = %{version}-%{release}
Provides:      golang(%{import_path}/service/elb/elbiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/emr) = %{version}-%{release}
Provides:      golang(%{import_path}/service/emr/emriface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/glacier) = %{version}-%{release}
Provides:      golang(%{import_path}/service/glacier/glacieriface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/iam) = %{version}-%{release}
Provides:      golang(%{import_path}/service/iam/iamiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/kinesis) = %{version}-%{release}
Provides:      golang(%{import_path}/service/kinesis/kinesisiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/kms) = %{version}-%{release}
Provides:      golang(%{import_path}/service/kms/kmsiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/lambda) = %{version}-%{release}
Provides:      golang(%{import_path}/service/lambda/lambdaiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/machinelearning) = %{version}-%{release}
Provides:      golang(%{import_path}/service/machinelearning/machinelearningiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/mobileanalytics) = %{version}-%{release}
Provides:      golang(%{import_path}/service/mobileanalytics/mobileanalyticsiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/opsworks) = %{version}-%{release}
Provides:      golang(%{import_path}/service/opsworks/opsworksiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/rds) = %{version}-%{release}
Provides:      golang(%{import_path}/service/rds/rdsiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/redshift) = %{version}-%{release}
Provides:      golang(%{import_path}/service/redshift/redshiftiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/route53) = %{version}-%{release}
Provides:      golang(%{import_path}/service/route53/route53iface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/route53domains) = %{version}-%{release}
Provides:      golang(%{import_path}/service/route53domains/route53domainsiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/s3) = %{version}-%{release}
Provides:      golang(%{import_path}/service/s3/s3iface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/s3/s3manager) = %{version}-%{release}
Provides:      golang(%{import_path}/service/ses) = %{version}-%{release}
Provides:      golang(%{import_path}/service/ses/sesiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/sns) = %{version}-%{release}
Provides:      golang(%{import_path}/service/sns/snsiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/sqs) = %{version}-%{release}
Provides:      golang(%{import_path}/service/sqs/sqsiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/ssm) = %{version}-%{release}
Provides:      golang(%{import_path}/service/ssm/ssmiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/storagegateway) = %{version}-%{release}
Provides:      golang(%{import_path}/service/storagegateway/storagegatewayiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/sts) = %{version}-%{release}
Provides:      golang(%{import_path}/service/sts/stsiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/support) = %{version}-%{release}
Provides:      golang(%{import_path}/service/support/supportiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/swf) = %{version}-%{release}
Provides:      golang(%{import_path}/service/swf/swfiface) = %{version}-%{release}
Provides:      golang(%{import_path}/service/workspaces) = %{version}-%{release}
Provides:      golang(%{import_path}/service/workspaces/workspacesiface) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%package unit-test
Summary:         Unit tests for %{name} package
%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{repo}-%{commit}

%build

%install
# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test} && 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go"); do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test.file-list
done
for file in $(find . -iname "*.json"); do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test.file-list
done
for file in ./aws/credentials/example.ini; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test.file-list
done
%endif

%if 0%{?with_devel}
sort -u -o devel.file-list devel.file-list
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%if ! 0%{?with_bundled}
export GOPATH=%{buildroot}/%{gopath}:%{gopath}
%else
export GOPATH=%{buildroot}/%{gopath}:$(pwd)/Godeps/_workspace:%{gopath}
%endif

%if ! 0%{?gotest:1}
%global gotest go test
%endif

%gotest %{import_path}/aws
%gotest %{import_path}/aws/awsutil
%gotest %{import_path}/aws/credentials
%gotest %{import_path}/internal/endpoints
%gotest %{import_path}/internal/model/api
%gotest %{import_path}/internal/protocol/ec2query
%gotest %{import_path}/internal/protocol/json/jsonutil
%gotest %{import_path}/internal/protocol/jsonrpc
%gotest %{import_path}/internal/protocol/query
%gotest %{import_path}/internal/protocol/restjson
%gotest %{import_path}/internal/protocol/restxml
%gotest %{import_path}/internal/signer/v4
%gotest %{import_path}/internal/test/integration/s3
%gotest %{import_path}/internal/test/integration/s3/s3manager
%gotest %{import_path}/service/autoscaling
%gotest %{import_path}/service/autoscaling/autoscalingiface
%gotest %{import_path}/service/cloudformation
%gotest %{import_path}/service/cloudformation/cloudformationiface
%gotest %{import_path}/service/cloudfront
%gotest %{import_path}/service/cloudfront/cloudfrontiface
%gotest %{import_path}/service/cloudhsm
%gotest %{import_path}/service/cloudhsm/cloudhsmiface
%gotest %{import_path}/service/cloudsearch
%gotest %{import_path}/service/cloudsearch/cloudsearchiface
%gotest %{import_path}/service/cloudsearchdomain
%gotest %{import_path}/service/cloudsearchdomain/cloudsearchdomainiface
%gotest %{import_path}/service/cloudtrail
%gotest %{import_path}/service/cloudtrail/cloudtrailiface
%gotest %{import_path}/service/cloudwatch
%gotest %{import_path}/service/cloudwatch/cloudwatchiface
%gotest %{import_path}/service/cloudwatchlogs
%gotest %{import_path}/service/cloudwatchlogs/cloudwatchlogsiface
%gotest %{import_path}/service/codedeploy
%gotest %{import_path}/service/codedeploy/codedeployiface
%gotest %{import_path}/service/cognitoidentity
%gotest %{import_path}/service/cognitoidentity/cognitoidentityiface
%gotest %{import_path}/service/cognitosync
%gotest %{import_path}/service/cognitosync/cognitosynciface
%gotest %{import_path}/service/configservice
%gotest %{import_path}/service/configservice/configserviceiface
%gotest %{import_path}/service/datapipeline
%gotest %{import_path}/service/datapipeline/datapipelineiface
%gotest %{import_path}/service/directconnect
%gotest %{import_path}/service/directconnect/directconnectiface
%gotest %{import_path}/service/directoryservice
%gotest %{import_path}/service/directoryservice/directoryserviceiface
%gotest %{import_path}/service/dynamodb
%gotest %{import_path}/service/dynamodb/dynamodbiface
%gotest %{import_path}/service/ec2
%gotest %{import_path}/service/ec2/ec2iface
%gotest %{import_path}/service/ecs
%gotest %{import_path}/service/ecs/ecsiface
%gotest %{import_path}/service/efs
%gotest %{import_path}/service/efs/efsiface
%gotest %{import_path}/service/elasticache
%gotest %{import_path}/service/elasticache/elasticacheiface
%gotest %{import_path}/service/elasticbeanstalk
%gotest %{import_path}/service/elasticbeanstalk/elasticbeanstalkiface
%gotest %{import_path}/service/elastictranscoder
%gotest %{import_path}/service/elastictranscoder/elastictranscoderiface
%gotest %{import_path}/service/elb
%gotest %{import_path}/service/elb/elbiface
%gotest %{import_path}/service/emr
%gotest %{import_path}/service/emr/emriface
%gotest %{import_path}/service/glacier
%gotest %{import_path}/service/glacier/glacieriface
%gotest %{import_path}/service/iam
%gotest %{import_path}/service/iam/iamiface
%gotest %{import_path}/service/kinesis
%gotest %{import_path}/service/kinesis/kinesisiface
%gotest %{import_path}/service/kms
%gotest %{import_path}/service/kms/kmsiface
%gotest %{import_path}/service/lambda
%gotest %{import_path}/service/lambda/lambdaiface
%gotest %{import_path}/service/machinelearning
%gotest %{import_path}/service/machinelearning/machinelearningiface
%gotest %{import_path}/service/mobileanalytics
%gotest %{import_path}/service/mobileanalytics/mobileanalyticsiface
%gotest %{import_path}/service/opsworks
%gotest %{import_path}/service/opsworks/opsworksiface
%gotest %{import_path}/service/rds
%gotest %{import_path}/service/rds/rdsiface
%gotest %{import_path}/service/redshift
%gotest %{import_path}/service/redshift/redshiftiface
%gotest %{import_path}/service/route53
%gotest %{import_path}/service/route53/route53iface
%gotest %{import_path}/service/route53domains
%gotest %{import_path}/service/route53domains/route53domainsiface
%gotest %{import_path}/service/s3
%gotest %{import_path}/service/s3/s3iface
#%%gotest %%{import_path}/service/s3/s3manager
%gotest %{import_path}/service/ses
%gotest %{import_path}/service/ses/sesiface
%gotest %{import_path}/service/sns
%gotest %{import_path}/service/sns/snsiface
%gotest %{import_path}/service/sqs
%gotest %{import_path}/service/sqs/sqsiface
%gotest %{import_path}/service/ssm
%gotest %{import_path}/service/ssm/ssmiface
%gotest %{import_path}/service/storagegateway
%gotest %{import_path}/service/storagegateway/storagegatewayiface
%gotest %{import_path}/service/sts
%gotest %{import_path}/service/sts/stsiface
%gotest %{import_path}/service/support
%gotest %{import_path}/service/support/supportiface
%gotest %{import_path}/service/swf
%gotest %{import_path}/service/swf/swfiface
%gotest %{import_path}/service/workspaces
%gotest %{import_path}/service/workspaces/workspacesiface
%endif

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%if 0%{?with_devel}
%files devel -f devel.file-list
%license LICENSE.txt
%doc README.md
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%files unit-test -f unit-test.file-list
%license LICENSE.txt
%doc README.md
%endif

%changelog
* Thu Oct 22 2015 jchaloup <jchaloup@redhat.com> - 0.9.5-1
- Bump to upstream f096b7d61df3d7d6d97f0e701f92616d1ea5420d
  related: #1269806

* Thu Oct 22 2015 jchaloup <jchaloup@redhat.com> - 0.9.4-1.rc5.1
- Bump to upstream 5c0313fff8cd85670ae4fc996254dd7d66cb4cf7
  related: #1269806

* Thu Oct 08 2015 jchaloup <jchaloup@redhat.com> - 0.6.1-1
- First package for Fedora
  resolves: #1269806
